unit UTestIBO;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  {$IFDEF ConditionalExpressions}{$if CompilerVersion >= 14} variants,{$IFEND}{$ENDIF} //Delphi 6 or above
  Dialogs, StdCtrls, IB_Ledger, Grids, IB_Grid, IB_Components,
  UCustomFlexCelReport, UIBOFlexCelReport, ComCtrls, ToolWin, ImgList,
  ActnList, Registry, UExcelAdapter, XLSAdapter, ShellApi;

type
  TFTestIBO = class(TForm)
    Memo1: TMemo;
    Report: TIBOFlexCelReport;
    IB_Connection: TIB_Connection;
    Country: TIB_Query;
    Customer: TIB_Query;
    DsCountry: TIB_DataSource;
    IB_Grid1: TIB_Grid;
    IB_Ledger1: TIB_Ledger;
    DsCustomer: TIB_DataSource;
    ActionList: TActionList;
    ActionExport: TAction;
    ActionExit: TAction;
    ImageList3: TImageList;
    ImageList2: TImageList;
    ImageList1: TImageList;
    ToolBar: TToolBar;
    btnGo: TToolButton;
    btnClose: TToolButton;
    XLSAdapter: TXLSAdapter;
    SaveDialog1: TSaveDialog;
    procedure ActionExitExecute(Sender: TObject);
    procedure ActionExportExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FTestIBO: TFTestIBO;

implementation

{$R *.dfm}

procedure TFTestIBO.ActionExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TFTestIBO.ActionExportExecute(Sender: TObject);
begin
  if not SaveDialog1.Execute then exit;
  if FileExists(SaveDialog1.FileName) then DeleteFile(SaveDialog1.FileName);
  Report.FileName:=SaveDialog1.FileName;
  Report.Run;
  ShellExecute(0, 'open', PCHAR(SaveDialog1.FileName),'','',SW_SHOWNORMAL);
end;

procedure TFTestIBO.FormCreate(Sender: TObject);
var
  Reg: TRegistry;
  SHPath: string;
begin
  try
    //Connect to IBO. This is not a serious approach, but since this is a demo...
    Reg:= TRegistry.Create(KEY_QUERY_VALUE);
    try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion', false);
      SHPath:=Reg.ReadString('CommonFilesDir');
    finally
      FreeAndNil(Reg);
    end; //finally


    IB_Connection.Path:= SHPath+'\Borland Shared\Data\'+'EMPLOYEE.GDB';
    IB_Connection.Connect;
  except
    on e:exception do
    begin
      Application.ShowException(e);
      close;
    end;
  end; //except
  Country.Open;
  Customer.Open;
end;

end.
