unit UMain;

interface

// For this demo to work on Intraweb 7, you MUST TURN LOCKONSUBMIT PROPERTY OFF ON THE FORM!
//From the IntraWeb FAQ at http://www.atozed.com/IntraWeb/FAQ/Usage.iwp :
(*
  My application freezes in IntraWeb 7 when I use SendFile, SendStream, or I perform a File-upload?

  IntraWeb 7.0 introduces a new feature called LockOnSubmit.
  This is to prevent the double-click on a form when a submit is still in progress.
  However, it is incompatible with certain other features.
  Two of these are the ones above.
  If you are performing any of these, make sure this property is set to False in the form.
*)


uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes,
  UFlexCelImport, DB, DBTables, UExcelAdapter, XLSAdapter,
  UCustomFlexCelReport, UFlexCelReport, IWCompEdit, IWCompText,
  IWCompLabel, Controls, IWVCLBaseControl, IWBaseControl,
  IWBaseHTMLControl, IWControl, IWCompButton, UFlxNumberFormat;

type
  TIWForm2 = class(TIWAppForm)
    IWButton1: TIWButton;
    IWButton2: TIWButton;
    IWLabel2: TIWLabel;
    IWText1: TIWText;
    IWFile1: TIWFile;
    IWLabel1: TIWLabel;
    Report: TFlexCelReport;
    XLSAdapter: TXLSAdapter;
    Cust: TTable;
    DataSource1: TDataSource;
    FlexCelImport: TFlexCelImport;
    procedure IWButton1Click(Sender: TObject);
    procedure IWButton2Click(Sender: TObject);
    procedure IWFile1ReceivedFile(ASender: TObject;
      const AFilename: String);
  public
  end;

implementation

{$R *.dfm}

procedure TIWForm2.IWButton1Click(Sender: TObject);
var
  MemStream: TMemoryStream;
begin
  MemStream:=TMemoryStream.Create;
  try
    Report.SavetoStream(MemStream);
    WebApplication.SendStream(MemStream,false,'application/vnd.ms-excel','report.xls');
    MemStream:=nil; //If we actually sent the stream, WebApplication.SendStream will free it.
  finally
    FreeAndNil(MemStream);
  end; //finally
end;


procedure TIWForm2.IWButton2Click(Sender: TObject);
var
  MemStream: TMemoryStream;
begin
  MemStream:=TMemoryStream.Create;
  try
    Report.SavetoStream(MemStream);
    WebApplication.SendStream(MemStream, true,'','report.xls'); //save as an attachment
    MemStream:=nil; //If we actually sent the stream, WebApplication.SendStream will free it.
  finally
    FreeAndNil(MemStream);
  end; //finally
end;


procedure TIWForm2.IWFile1ReceivedFile(ASender: TObject;
  const AFilename: String);
var
  MemStream: TMemoryStream;
  Color: integer;
begin
  MemStream:=TMemoryStream.Create;
  try
    IWFile1.SaveToStream(MemStream);
    MemStream.Position:=0;
    FlexCelImport.LoadFromStream(MemStream);
    WebApplication.ShowMessage('Cell A1: "'+XlsFormatValue(FlexCelImport.CellValue[1,1],FlexCelImport.CellFormatDef[1, 1].Format,Color)+'"',
                               smAlert);
  finally
    FreeAndNil(MemStream);
  end; //finally
end;

initialization
  TIWForm2.SetAsMainForm;

end.
