unit UPreview;
{$IFDEF LINUX}{$INCLUDE ../../FLXCONFIG.INC}{$ELSE}{$INCLUDE ..\..\FLXCONFIG.INC}{$ENDIF}

interface

uses
  SysUtils, Classes,
  {$IFDEF FLX_VCL}
    Graphics, Controls, Forms, Dialogs, Menus, ActnList,
    StdCtrls, ComCtrls, ImgList, ToolWin, ExtCtrls, Grids, Printers,
  {$ENDIF}
  {$IFDEF FLX_CLX}
    QGraphics, QControls, QForms, QDialogs, QMenus, QActnList,
    QStdCtrls, QComCtrls, QImgList, QTypes, QExtCtrls, QGrids, QPrinters,
  {$ENDIF}

  UExcelAdapter, XLSAdapter,
  UFlexCelImport, UFlexCelGrid, UFlexCelPreview;

type
  TFPreview = class(TForm)
    FlexCelPreview1: TFlexCelPreview;
    StatusBar: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton13: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    ImageList1: TImageList;
    ImageList2: TImageList;
    ImageList3: TImageList;
    ActionList: TActionList;
    ActionPrint: TAction;
    ActionClose: TAction;
    ComboZoom: TComboBox;
    procedure FlexCelPreview1PageChange(const Sender: TFlexCelPreview;
      const PageNumber, TotalPages: Integer);
    procedure ActionCloseExecute(Sender: TObject);
    procedure ActionPrintExecute(Sender: TObject);
    procedure ComboZoomChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FPreview: TFPreview;

implementation

{$IFDEF FLX_VCL}
  {$R *.dfm}
{$ENDIF}
{$IFDEF FLX_CLX}
  {$R *.xfm}
{$ENDIF}

procedure TFPreview.FlexCelPreview1PageChange(
  const Sender: TFlexCelPreview; const PageNumber, TotalPages: Integer);
begin
  StatusBar.SimpleText:=Format('Page %d of %d',[PageNumber, TotalPages]);
end;

procedure TFPreview.ActionCloseExecute(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

procedure TFPreview.ActionPrintExecute(Sender: TObject);
begin
 ModalResult:=mrOk;
end;

procedure TFPreview.ComboZoomChange(Sender: TObject);
begin
  FlexCelPreview1.ZoomPreview:=StrToInt(Trim(copy(ComboZoom.Text,1, Length(ComboZoom.Text)-1)));
end;

end.
